
#include <iostream>
#include <cstdio>

using namespace std;
#define CZ ('z'-'a'+1)
#define INVC CZ
#define MAX (2000000001LL)
bool taboo[CZ+1][CZ+1][CZ+1];
char buf[21];
char ans[21];
long long tbl[CZ+1][CZ+1][21];


long long calc_len(char p1, char p2, int len){
	if(len == 0) return 1;
	if(len >= 20) return MAX;
	if(tbl[p1][p2][len] != -1)
		return tbl[p1][p2][len];
	long long ans = 0;
	for(int p3=0; p3<CZ; p3++)
		if(!taboo[p1][p2][p3])
			ans += calc_len(p2, p3, len-1);
	return tbl[p1][p2][len] = ans;
}

void find(int idx, char p1, char p2, int len, long long n){
	long long prev = 0;
	int p3 = 0;
	for(p3 = 0; p3 < CZ; p3++){
		if(taboo[p1][p2][p3]) continue;
		long long t =  calc_len(p2, p3, len-1);
		if(prev+t >=n) break;
		prev += t;
	}
	ans[idx] = 'a'+p3;
	if(len != 1)
		find(idx+1, p2, p3, len-1, n-prev);
}

int cmp(char *p1, char*p2){
	int len1 = strlen(p1);
	int len2 = strlen(p2);
	if(len1 < len2) return -1;
	if(len1 > len2) return 1;
	return strcmp(p1,p2);
}

void find(long long n){
	int len = 1;
	int skip = 0;
	while(n>calc_len(INVC, INVC, len)){
		n -= calc_len(INVC, INVC, len);
		len++;
	}
	ans[len] = '\0';
	find(0, INVC, INVC, len, n);
}

int main(void){
	int cases;
	scanf("%d", &cases);
	while(cases--){
		int n,q;
		scanf("%d %d", &n, &q);
		memset(taboo, 0, sizeof(taboo));
		while(n--){
			scanf(" %s", buf);
			int len  = strlen(buf);
			if(len==1){
				for(int i=0;i<CZ+1;i++)
					for(int j=0;j<CZ+1;j++)
						taboo[i][j][buf[0]-'a'] = true;
			}else if(len == 2){
				for(int i=0;i<CZ+1;i++)
					taboo[i][buf[0]-'a'][buf[1]-'a'] = true;
			}else{
				taboo[buf[0]-'a'][buf[1]-'a'][buf[2]-'a'] = true;
			}
		}
		memset(tbl,-1, sizeof(tbl));
		while(q--){
			scanf("%s", buf);
			if(isdigit(buf[0])){
				int n = atoi(buf);
				find(n);
				printf("%s\n", ans);
			}else{
				long long low = 1, high = MAX, mid;
				while(true){
					mid = (low+high)>>1;
					find(mid);
					int res = cmp(buf, ans);
					if(res < 0){
						high = mid;
					}else if(res > 0){
						low = mid;
					}else{
						low = mid;
						break;
					}
				}
				printf("%d\n", low);
			}
		}
	}
	return 0;
}
